#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <libirc.h>
#include <getopt.h>
#include <sys/types.h>
#include <time.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

const        char    appinfo[]="Mojodo Project Code ,no (c) 2002";
const        char    license[]="GNU/GPL";
const        char    version[]="0.2b";
struct skin{
    char nick[12], user[12], realname[50];
};
struct mucca_opt{
    char *server, *skin;
    int v6, port;
};
struct fields{
    char name[100];
    char value[100];
};

FILE *stdlog;

int getopt_long_only(int argc, char * const argv[],const char *optstring,const struct option *longopts, int *longindex);
void usage(char *bin);
void loadfile(char *skindir, struct skin *skinopt);
int ArtificialStupidity(char *skindir, char *msg, char *risp);
void get_pass(char *skindir, char *pass);
int auth(char *login,char *pass);
void loadchannels(char *skindir,int sockfd);
int charcnt(char *string, char c);
void startlog(char *skinname);
char *mukkatime(void);
void addphrase(char *skinname,char *phrase,char *answer);
void help(int sockfd,char *dest);
int close(int fd);
int fclose(FILE *stream);
pid_t fork(void);
void free(void *ptr);

int main(int argc, char **argv){
	int sockfd, i, opt_index;
	char msg[1024],cmd[1024],c, syspass[100];
	pid_t pid;
	struct skin skin;
	struct mucca_opt mucca_opt;
	struct li_settings settings;
	struct li_srvline srvline;
	struct option opzioni[]={
		{"skin", 1, 0, 0},
		{"srv", 1, 0, 0},
		{"srv6", 1, 0, 0},
		{"port", 1, 0, 0},
		{"help", 0, 0, 0},
		{0, 0, 0, 0}
	};

	if(argc<3)
		usage(argv[0]);

	memset(&settings,0,sizeof(settings));
	memset(&srvline,0,sizeof(srvline));
	memset(&skin,0,sizeof(skin));
	memset(&syspass,0,sizeof(syspass));
	memset(&mucca_opt,0,sizeof(mucca_opt));

	while ((c=getopt_long(argc,argv,"skin:srv:srv6:port:help:",opzioni,&opt_index))!=-1){
		switch (c) {
			case 0:
				if (!strcmp(opzioni[opt_index].name,"help"))
					usage(argv[0]);
				else if (!strcmp(opzioni[opt_index].name,"skin")){
					mucca_opt.skin=malloc(strlen(optarg));
					memcpy(mucca_opt.skin,optarg,strlen(optarg));
		 		}
				else if (!strcmp(opzioni[opt_index].name,"srv")){
					mucca_opt.server=malloc(strlen(optarg));
					memcpy(mucca_opt.server,optarg,strlen(optarg));
		 		}
				else if (!strcmp(opzioni[opt_index].name,"srv6")){
					mucca_opt.v6=1;
					mucca_opt.server=malloc(strlen(optarg));
					memcpy(mucca_opt.server,optarg,strlen(optarg));
		 		}
				else if (!strcmp(opzioni[opt_index].name,"port"))
					mucca_opt.port=atoi(optarg);
			break;
		}
	}
	if(!(mucca_opt.server) || !(mucca_opt.port) || !(mucca_opt.skin))
		usage(argv[0]);
	fprintf(stdout,"Mukk4! b0t...\n");
	fprintf(stdout," %s License:%s\n",appinfo,license);
	fprintf(stdout," libirc: %s\n",li_version());
	fprintf(stdout," skin: %s\n",mucca_opt.skin);
	loadfile(mucca_opt.skin,&skin);
	get_pass(mucca_opt.skin,syspass);
	startlog(mucca_opt.skin);
	strncpy(settings.nick,skin.nick,10);
	strncpy(settings.user,skin.user,10);
	strncpy(settings.realname,skin.realname,10);

	if(mucca_opt.v6)
		sockfd=li_connect6(mucca_opt.server,6667,settings);
	else
		sockfd=li_connect4(mucca_opt.server,6667,settings);
	loadchannels(mucca_opt.skin,sockfd);
	switch (pid = fork ()){
		case 0:
			break;
		default:
			printf(" b0t pid is %d\n",pid);
			printf("b0t Started.\n");
			exit (0);
	}
	i=0;
	while(sockfd){
		i++;
		memset(msg,0,sizeof(char *));
		strncpy(msg,li_read(sockfd),1024);
		if ((msg) && (strstr(msg,"PING :"))){
			li_pong(sockfd,msg);
		}
		else if (strstr(msg,"ERROR :Closing Link:")){
			if ((msg[0]=='E') && (msg[4]=='R') && (msg[6]==':')){
				close(sockfd);
				if(mucca_opt.v6)
					sockfd=li_connect6(mucca_opt.server,6667,settings);
				else
					sockfd=li_connect4(mucca_opt.server,6667,settings);
				fprintf(stdlog,"[%s]\tdisconnect from server:\"%s\"",mukkatime(),srvline.msg);
				fflush(stdlog);
				loadchannels(mucca_opt.skin,sockfd);
			}
		}
		else if ((msg) && (strstr(msg,"PRIVMSG"))){
			char risp[100];
			memset(&risp,0,100);
			li_getline(msg,&srvline);
			if (strcmp(srvline.nick,settings.nick)){
			if ((strstr(srvline.msg,"!op "))){
				char login[100],pass[100], chan[30], *p_msg;
				memset(&login,0,100);
				memset(&pass,0,100);
				memset(&chan,0,100);
				p_msg=srvline.msg;
				while(*(p_msg++)!=' ');
				if(strlen(p_msg)>2)
					strncpy(login,strtok(p_msg," "),100);
				while(*(p_msg++)!='\0');
				if(strlen(p_msg)>2)
					strncpy(pass,strtok(p_msg," "),100);
				while(*(p_msg++)!='\0');
				if(strlen(p_msg)>2)
					strncpy(chan,strtok(p_msg,"\r\n"),30);
				fprintf(stdlog,"[%s]\top on %s from %s[%s]:",mukkatime(),chan,srvline.nick,srvline.net);
				if(auth(login,pass)){
					char msg_cmd[1024];
					sprintf(msg_cmd,"mode %s +o %s\n",chan,srvline.nick);
					li_write(sockfd,msg_cmd);
					fprintf(stdlog,"[accept]\n");
				}
				else {
					char msg_cmd[1024];
					sprintf(msg_cmd,"privmsg %s :Login or Password Incorrect\n",srvline.nick);
					li_write(sockfd,msg_cmd);
					fprintf(stdlog,"[failed]\n");
				}
				fflush(stdout);
			}
			else if ((strstr(srvline.msg,"!deop "))){
				char login[100],pass[100], chan[100],dest[100], *p_msg;
				memset(&login,0,100);
				memset(&pass,0,100);
				memset(&chan,0,100);
				memset(&dest,0,100);
				p_msg=srvline.msg;
				while(*(p_msg++)!=' ');
				if(strlen(p_msg)>2)
					strncpy(login,strtok(p_msg," "),100);
				while(*(p_msg++)!='\0');
				if(strlen(p_msg)>2)
					strncpy(pass,strtok(p_msg," "),100);
				while(*(p_msg++)!='\0');
				if(strlen(p_msg)>2)
					strncpy(chan,strtok(p_msg," "),100);
				while(*(p_msg++)!='\0');
				if(strlen(p_msg)>2)
					strncpy(dest,strtok(p_msg,"\0"),100);
				fprintf(stdlog,"[%s]\tdeop on %s for %s from %s[%s]:",mukkatime(),chan,dest,srvline.nick,srvline.net);
				if(auth(login,pass)){
					char msg_cmd[1024];
					sprintf(msg_cmd,"mode %s -o %s\n",chan,dest);
					li_write(sockfd,msg_cmd);
					fprintf(stdlog,"[accept]\n");
				}
				else {
					char msg_cmd[1024];
					sprintf(msg_cmd,"privmsg %s :Login or Password Incorrect\n",srvline.nick);
					li_write(sockfd,msg_cmd);
					fprintf(stdlog,"[failed]\n");
				}
				fflush(stdlog);
			}
			else if ((strstr(srvline.msg,"!cmd "))){
				char pass[100], msg_cmd[1024], *p_msg;
				memset(&pass,0,100);
				memset(&msg_cmd,0,1024);
				p_msg=srvline.msg;
				while(*(p_msg++)!=' ');
				if(strlen(p_msg)>2)
					strncpy(pass,strtok(p_msg," "),100);
				while(*(p_msg++)!='\0');
				if(strlen(p_msg)>2)
					strncpy(msg_cmd,strtok(p_msg,"\r"),1024);
				if(strcmp(pass,syspass)==0)
					li_write(sockfd, msg_cmd);

				li_write(sockfd, "\n");
			}
			else if ((strstr(srvline.msg,"!die "))){
				char pass[100], *p_msg;
				memset(&pass,0,100);
				p_msg=srvline.msg;
				while(*(p_msg++)!=' ');
				if(strlen(p_msg)>2)
					strncpy(pass,strtok(p_msg,"\r"),100);
				fprintf(stdlog,"[%s]\tDie Request from %s[%s]",mukkatime(),srvline.nick,srvline.net);
				if (strcmp(pass,syspass)==0){
					li_write(sockfd,"quit :Die Request\n");
					close(sockfd);
					fprintf(stdlog,":Died.\n");
					fflush(stdlog);
					exit(0);
				}
				fflush(stdlog);
			}
			else if ((strstr(srvline.msg,"!info"))){
				memset(&cmd,0,1024);
				if (strstr(srvline.dest,"#")){
					sprintf(cmd,"PRIVMSG %s :Mukk4! B0t... Cow Power\n",srvline.dest);
					li_write(sockfd,cmd);
					sprintf(cmd,"PRIVMSG %s :  Un Muggito nella Savana\n",srvline.dest);
					li_write(sockfd,cmd);
					sprintf(cmd,"PRIVMSG %s :  %s   License: %s\n",srvline.dest,appinfo,license);
					li_write(sockfd,cmd);
					sprintf(cmd,"PRIVMSG %s :  Version: %s   Skin: %s\n",srvline.dest, version,mucca_opt.skin);
					li_write(sockfd,cmd);
					sprintf(cmd,"PRIVMSG %s :  Talk System: ASv2, Artificial Stupidity v2\n",srvline.dest);
					li_write(sockfd,cmd);
					sprintf(cmd,"PRIVMSG %s :  WebSite: http://www.mojodo.it\n",srvline.dest);
					li_write(sockfd,cmd);
				}
			}
			else if ((strstr(srvline.msg,"!rehash "))){
				char pass[100], *p_msg;
				p_msg=srvline.msg;
				fprintf(stdlog,"[%s]\tRehash Request from %s\n",mukkatime(),srvline.nick);
				while(*(p_msg++)!=' ');
				if(strlen(p_msg)>2)
					strncpy(pass,strtok(p_msg,"\r"),10);
				while(*(p_msg++)!='\0');
				if(strcmp(pass,syspass)==0){
					loadfile(mucca_opt.skin,&skin);
					get_pass(mucca_opt.skin,syspass);
					li_set_nick(sockfd,skin.nick);
				}
				fflush(stdlog);
			}
			else if ((strstr(srvline.msg,"!join "))){
				char chan[100], pass[100], *p_msg;
				p_msg=srvline.msg;
				memset(&pass,0,100);
				memset(&chan,0,100);
				while(*(p_msg++)!=' ');
				if(strlen(p_msg)>2)
					strncpy(pass,strtok(p_msg," "),100);
				while(*(p_msg++)!='\0');
				if(strlen(p_msg)>2)
					strncpy(chan,strtok(p_msg,"\r"),100);
				while(*(p_msg++)!='\0');
				fprintf(stdlog,"[%s]\tRequest join to %s from %s[%s]:",mukkatime(),chan,srvline.nick,srvline.net);
				if(strcmp(pass,syspass)==0){
					li_join(sockfd,chan,NULL);
					fprintf(stdlog,"[accept]\n");
				}
				else { fprintf(stdlog,"[failed]\n"); }
				fflush(stdlog);
			}
			else if ((strstr(srvline.msg,"!part "))){
				char chan[100], pass[100], *p_msg;
				p_msg=srvline.msg;
				memset(&pass,0,100);
				memset(&chan,0,100);
				while(*(p_msg++)!=' ');
				if(strlen(p_msg)>2)
					strncpy(pass,strtok(p_msg," "),100);
				while(*(p_msg++)!='\0');
				if(strlen(p_msg)>2)
					strncpy(chan,strtok(p_msg,"\r"),100);
				while(*(p_msg++)!='\0');
				fprintf(stdlog,"[%s]\tRequest part to %s from %s[%s]:",mukkatime(),chan,srvline.nick,srvline.net);
				if(strcmp(pass,syspass)==0){
					li_part(sockfd,chan);
					fprintf(stdlog,"[accept]\n");
				}
				else { fprintf(stdlog,"[failed]\n"); }
				fflush(stdlog);
			}
			else if ((strstr(srvline.msg,"!addphrase "))){
				char pass[100], *p_msg;
				char phrase[100],answer[100];
				p_msg=srvline.msg;
				memset(&pass,0,100);
				memset(&phrase,0,100);
				memset(&answer,0,100);
				while(*(p_msg++)!=' ');
				if(strlen(p_msg)>2)
					strncpy(pass,strtok(p_msg," "),100);
				while(*(p_msg++)!='\"');
				if(strlen(p_msg)>2)
					strncpy(phrase,strtok(p_msg,"\""),100);
				while(*(p_msg++)!='\"');
				if(strlen(p_msg)>2)
					strncpy(answer,strtok(p_msg,"\""),100);
				while(*(p_msg++)!='\0');
				fprintf(stdlog,"[%s]\tphrase added from %s[%s]:",mukkatime(),srvline.nick,srvline.net);
				if(strcmp(pass,syspass)==0){
					addphrase(mucca_opt.skin,phrase,answer);
					fprintf(stdlog,"[accept]\n");
				}
				else { fprintf(stdlog,"[failed]\n"); }
				fflush(stdlog);
			}
			else if ((strstr(srvline.msg,"!help"))){
				help(sockfd,srvline.nick);
			}
			else if ((strstr(srvline.msg,"!mail "))){
				int mailfd;
				struct sockaddr_in sockmail;
				struct hostent *host_ent;
				//const char sender[]="mukkabot@denialofservice.it\0";
				//const char subject[]="IRC Mail From Mukkabot\0";
				const char mailsrv[]="mail.denialofservice.it\0";

				memset(&sockmail,0,sizeof(struct sockaddr_in));
  				if((host_ent=gethostbyname(mailsrv)) != NULL) {
					memcpy((char *)&sockmail.sin_addr,host_ent->h_addr,host_ent->h_length);
					sock_addr.sin_family = PF_INET;
					sock_addr.sin_port = htons(25);
					if((mailfd = socket(PF_INET, SOCK_STREAM,0))> 0)
						if(connect(mailfd,(struct sockaddr *)&sockmail,sizeof(struct sockaddr_in))> 0){
						
						}
					}
				}

			}
			else if (ArtificialStupidity(mucca_opt.skin,srvline.msg,risp)){
				char msg_cmd[1024];
				if (strstr(srvline.dest,"#")){
					li_say(sockfd,srvline.dest ,risp);
				}
				else {
					li_say(sockfd,srvline.nick ,risp);
				}
				li_write(sockfd,msg_cmd);
			}
			}
		}
	free(msg);
	return(0);
}

void usage(char *bin){
	printf("Mukk4! B0t... The Cow Power!\n");
	printf(" Coder: ValK\n");
	printf(" Un Muggito nella Savana\n");
	printf(" %s\n",appinfo);
	printf(" License: %s\n",license);
	printf(" http://www.mojodo.it\n");
	printf(" Usage: %s --skin <name> --srv/--srv6 <server> --port <port>\n",bin);
	exit(0);
}

void help(int sockfd,char *dest){
	char cmd[1024];
	memset(&cmd,0,1024);
	if (!strstr(dest,"#")){
		sprintf(cmd,"PRIVMSG %s :Mukk4! b0t: [help]\n",dest);
		li_write(sockfd,cmd);
		sprintf(cmd,"PRIVMSG %s : !info\n",dest);
		li_write(sockfd,cmd);
		sprintf(cmd,"PRIVMSG %s : !addphrase <sys pwd> \"<phrase>\" \"<answer>\"\n",dest);
		li_write(sockfd,cmd);
		sprintf(cmd,"PRIVMSG %s : !rehash <sys pwd>\n",dest);
		li_write(sockfd,cmd);
		sprintf(cmd,"PRIVMSG %s : !cmd <sys pwd> <raw irc command>\n",dest);
		li_write(sockfd,cmd);
		sprintf(cmd,"PRIVMSG %s : !die <sys pwd>\n",dest);
		li_write(sockfd,cmd);
		sprintf(cmd,"PRIVMSG %s : !join <sys pwd> <channel> <ch_key>\n",dest);
		li_write(sockfd,cmd);
		sprintf(cmd,"PRIVMSG %s : !part <sys pwd> <channel>\n",dest);
		li_write(sockfd,cmd);
		sprintf(cmd,"PRIVMSG %s : !op <user> <pwd> <channel>\n",dest);
		li_write(sockfd,cmd);
		sprintf(cmd,"PRIVMSG %s : !deop <user> <pwd> <channel> <vittim>\n",dest);
		li_write(sockfd,cmd);
		}
}
